#!/usr/local/bin/tclsh
#
# test-syl.tcl
#
# Perform some tests of the syllify script
#
# 1997jun09 dpwe@icsi.berkeley.edu
# $Header: /u/drspeech/src/syllify/RCS/test-syl.tcl,v 1.3 1998/07/26 03:40:59 dpwe Exp $

# Do the tests right here, in the src directory

proc Exec {cmd {docatch 0}} {
    # exec the command, but echo it too
    puts $cmd
    if {$docatch} {
	eval "catch \{exec $cmd\} rslt"
    } else {
	set rslt [eval "exec $cmd"]
    }
    return $rslt
}

set datadir [file dirname [info script]]/testdata

Exec "rm -rf $datadir/phn $datadir/syl"
Exec "cp -r $datadir/refphn $datadir/phn"
Exec "mkdir $datadir/syl"

set ids "2794-A-0102 2334-A-0083 4348-A-0043 4166-B-0011 3429-B-0039"

set listfile "$datadir/test.list"
set f [open $listfile "w"]
puts $f "# Test data"
foreach id $ids {
    puts $f "$id  plus a bunch of garbage"
}
close $f

puts stderr [Exec "./syllify listfile=$listfile phndirectory=$datadir/phn syldirectory=$datadir/syl labeltype=xlabel verbose=1 mergecls=0" 1]

foreach id $ids {
    puts "Comparing outputs for $id:"
    catch {exec diff $datadir/refsyl/$id.syl $datadir/syl/$id.syl} rslt
    puts $rslt
}

file delete $listfile
Exec "rm -rf $datadir/phn $datadir/syl"
