. $Header: /u/drspeech/src/syllify/RCS/syllify.man,v 1.7 1998/08/03 23:08:18 dpwe Exp $
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.TH SYLLIFY 1 "1997jun08" dpwe   \" $Header: /u/drspeech/src/syllify/RCS/syllify.man,v 1.7 1998/08/03 23:08:18 dpwe Exp $
.SH NAME
syllify \- Convert phonemic labels to syllabic via TSYLB
.SH SYNOPSIS
.B syllify
[\fBphndirectory\fR=<dir>]
[\fBsyldirectory\fR=<dir>]
[\fIother opts\fR]
{\fBlistfile\fR=<idlist(s)> | \fIuttids\fR}
.SH DESCRIPTION
.PP
This program is used to convert a collection of speech-transcription
phonetic-label files to syllable-label files, which are essentially
the same information, but grouped by syllables.  In general, the new
labels are formed by grouping together one or more of the phoneme
labels; the content of the new labels is the component phonemes
(separated by spaces) and the time support of the new labels matches
the union of the times covered by the phonemes.  This program is
useful for people working with syllable recognition, but who wish to
exploit the more common phoneme-based training corpora.
.PP
The core of the program is actally the syllabifier program
.MS tsylb2 1
written by Bill Fisher of NIST, which is itself an implementation of the 
rules described in Dan Kahn's 1976 thesis.  The 
.MS tsylb2 1 
program runs interactively, taking prompted input from the console, and 
printing out formatted displays.  The purpose of the 
.PN syllify
script is to read a batch of phoneme label files, feed them to 
.PN tsylb2
in a format it accepts, then extract the syllabification information from 
its output.  In the process, 
.PN syllify
handles issues such as label file format conversion, phoneset 
mappings, segmentation on "h#" (nonspeech) tokens, and reassignment of 
diacritics.

.SH OPTIONS
The following options are accepted (defaults in parens):
.SS Finding input and output files
.TP
.B listfile=\fIidlists\fR (required unless ids given on command line)
the names of one or more files specifying the ids of the 
utterances to be converted, one per line. 
If more than one file is provided (as a space-delimited list, which you'd 
normally have to put in quotes to stop the shell breaking it up), the 
output consists of all the utterances specified in the first file, then 
all the ones from the second list etc.  Normally the utterances are 
specified by the utterance ID, a short token in a format defined for 
each database, which is then converted into the name of a transcription 
file as described under the phnfilecmd option below.
.IP
Utterance IDs may also be directly specified on the command line; when 
both individual IDs and one or more listfiles are specified, the 
command-line IDs are processed first, followed by those read from the 
listfile.
.P
.PD 0
.B phndirectory=\fIdir\fR (".")
.P
.B phnextension=\fIext\fR (".phn")
.TP
.PD 1
.B phnfilecmd=\fIcmd\fR (none)
There are two ways that 
.I syllify
can map the utterance IDs it reads from the list file(s) into 
filenames for the various transcription files that it will convert.  
The first option is to construct a file path name as 
\fI<phndirectory>\fR/\fI<uttid><phnextension>\fR, 
which works if all the transcription files are in a single 
directory and the utterance IDs bear such a simple relationship to 
the filenames (also, if the list files contain full pathnames rather 
than simple utterance IDs, this is the approach to use with both
phndirectory and phnextension set to "").  
Alternatively, if \f4phnfilecmd\f1 is defined, it is taken as a 
command line that will be executed to map an utterance ID to the 
name of a transcription file, for instance 
.MS numbers95_findfile 1 
and 
.MS bn_file 1 .  The script will replace any occurrence of "%u" in 
the command string with the utterance ID for which the transcription is 
desired.  If there is no "%u" in the command string, the utterance ID will 
simply be appended, without any intervening space.
See the EXAMPLES section.
.P
.PD 0
.B syldirectory=\fIdir\fR (".")
.P
.B sylextension=\fIext\fR (".sy;")
.TP
.PD 1
.B sylfilecmd=\fIcmd\fR (none)
Specify the form of the output syllable label file names in a manner 
analogous to the input phoneme label file names (phnfilecmd etc).
.TP
.B sent_start=\fInum\fR (0 i.e. first utterance)
After reading all the lists of utterance IDs to process, start with this 
one i.e. skip this many utterances from the start of the list.
.TP
.B sent_count=\fInum\fR (0 i.e. all remaining utterances)
Process at most this many utterances i.e. assuming the utterance ID list 
is long enough, this is how many of them will be processed.  Anything 
smaller than 1 is treated as meaning continue until the list is exhausted.
.SS Defining the format of the transcription label files
.TP
.B labeltype=\fItype\fR ("timit")
The format of the transcription label files.  This can be "timit" (for 
TIMIT-style files; see \f4label_framerate\f1 below), "xlabel" (for the label 
files written by ESPS's
.MS xlabel 1 
tool), "noway" or "noway2" (for alignment files written by Noway, 
version 1.x or 2.x respectively).
.TP
.B label_framerate=\fIrate_Hz\fR (1000.0 Hz)
The units to be used when interpreting the frame counts in TIMIT-format 
label files, which specify start and end times in integer counts of 
frames.  With the default value of 1000 Hz, the counts are assumed to 
be of milliseconds.  Note that since the units are the same for input 
and output label files, this setting has no visible effect at present.
.TP
\fBrunmode=\fImode\fR
Select between three operating modes for this run.  \f4runmode=normal\f1 (the 
default) converts input phoneme label files to output syllable label 
files, and reports only warnings that occur during the translation (such 
as unexpected repeated phonemes, or "unnatural" syllabifications).  
\f4runmode=verbose\f1 does the same, but each syllabification is summarized to 
the terminal as it is written.  \f4runmode=rehearse\f1 also prints the 
summarized syllabifications and any warnings to the terminal, but does not 
actually write the syllable label files, to use the script simply to check 
the suitability of a batch of phoneme label files for syllabification.
.TP
.B keepdias=\fIbool\fR (1)
This option controls the treatment of 
diacritics (extensions to phoneme labels of the form "_cr", "_n" etc. 
which indicate a deviation from the canonical form of the segment as 
croaky, nasalized etc.)  Diacritics must be stripped as part of the 
preprocessing required for \f4tsylb\f1.  Normally they are restored to the 
output token to which the input label contributed; with 
\f4keepdias=0\f1, they are simply discarded.
.TP
.B mergecls=\fIbool\fR (0)
Closure labels (e.g. pcl, tcl) are not known to tsylb, and thus 
must be pre-processed in some way.  The default behavior is to 
merge them when they are followed by corresponding bursts (i.e. "tcl t") 
but to leave them as separate instances of the stop in other cases 
(thus "tcl ch" becomes "t ch").  Alternatively, specifying \f4mergecls=1\f1, 
the closure is merged into the following label whatever it is, but 
a warning is printed if it is not the canonical release.  
This may hide closures that are intended as 
syllable-final stops. (See BUGS).
.TP
.B xs2next=\fIbool\fR (0)
.I tsylb
may occasionally leave phones outside of any syllable as 'extrasyllabics'.  
Since we want syllables, these are simply attached to the nearest available 
syllable, but when the extrasyllabic occurs between two syllables, it 
could go either way.  This flag controls whether they are blindly 
attached to the front of the following syllable (\f4xs2next=1\f1) or 
the end of the preceding syllable (\f4xs2next=0\f1).
.TP
.B map61to56=\fIbool\fR (1)
As a special time-saving feature, this option will automatically perform 
the symbolic mapping of the extra phones in the TIMIT61 phone symbol 
set to their equivalents in the standard ICSI56 phone set.  
I believe the default 
.MS tsylb 1
mapping tables that we have defined don't have the full TIMIT61 set, 
so make sure you use this if your data is TIMIT61.
.TP
.B tsylb_bin=\fIpath\fR (/u/stp/src/tsylb2-1.1/tsylb2)
The path to the executable tsylb binary.  If the shell environment variable
TSYLBBIN is set, it is used as the default.
.TP
.B tsylb_args=\fIargs\fR (-f phon1ax.pcd)
Arguments to tsylb, which define the phoneset translation and 
syllabifaction tables to be used.
.TP
.B debug=\fIbool\fR (0)
Print extra debugging information
.TP
.B verbose=\fIbool\fR (0)
Print progress information, one line per completed file.
.TP
.B help=\fIany\fR ()
Just print the usage message and quit.
.SH OTHER OPTIONS
Within the script, there is a list of phoneme token mappings (\f4tokenmap\f1) 
and patterns to trigger warnings (\f4warns\f1) which could be edited easily to 
customize the program.  Although it might be desirable to make these 
command-line options, I'm not sure how to allow the user to specify them 
in a robust manner.  (\f4tokenmap\f1 is a Tcl list of "regsub" pairs; 
\f4warns\f1 is a list of "glob" patterns).  
.PP
As it stands, \f4tokenmap\f1 makes the following translations:
phoneme labels "UNL", "unl", "?" and "!" become "" (i.e. they are deleted, 
meaning their time support is merged with the following phoneme); 
"SIL", "sil", "SP" and "sp" are mapped to "h#", the generic ICSI-56 
silence/nonspeech label.  This map is augmented by the TIMIT-to-ICSI
rules when map61to56 is specified.
.SH EXAMPLES
To generate syllabified versions of the numbers95 training set 
from the OGI hand-labelled files:
.EX
syllify \\
  listfile=/u/drspeech/data/NUMBERS95/list/numbers95-cs-train-rand.utids \\
  phnfilecmd='numbers95_findfile type=phn prefix=/u/drspeech/data/NUMBERS95 utid=%u' \\
  labeltype=timit \\
  syldirectory=syl
.EE
Each syllabified file will be written into "./syl/<id>.syl", where <id>
is the standard numbers95 utterance ID (e.g. 442st).
.SH BUGS
Tsylb doesn't handle separate stop-closure symbols, so these are all 
collapsed into the following matching release by default, otherwise 
left as separate stops.  Unfortunately, when 
a closure is not followed by the corresponding release, this can 
cause weirdness.  For instance, in the NUMBERS95 hand transcriptions, 
the <tcl> symbol is often used where a glottal stop (<q>) might be 
preferred; this final-tcl is typically lost during the tsylb 
preprocessing (with a warning such as "tcl merged to *END*").
Really, we should handle this more intelligently, to permit 
separate treatment of final-closures and pre-burst closures.
.P
The options which currently require editing the script should be made 
command-line options.
.PP
It depends on 
.PN tsylb2
being installed, and on knowing where to find it.  Our installed version of 
.PN tsylb2
is slightly patched to be ICSI-56 phoneset friendly, but these changes 
aren't documented, so they will be lost if we install a new version.
.SH SEE ALSO
.MS tsylb2 1 ,
.MS labels2pfile 1 .
.SH AUTHOR
DAn Ellis, 
.B dpwe@icsi.berkeley.edu
