. $Header: /u/drspeech/src/syllify/RCS/syllify_lexicon.man,v 1.2 1998/10/31 02:42:42 fosler Exp $
.de EX		\" Begin Example
.ie \\n(.$ .nr EX \\$1n
.el \{\
.	ie n .nr EX 0n
.	el .nr EX 0n
.\}
.in +\\n(EXu
.if n .sp 1
.if t .sp .5v
.nf
.CW
.ft CB
..
.de EE		\" End example
.in -\\n(EXu
.fi
.}f             \" restore basic text attributes
.if n .sp 1
.if t .sp .5v
..
.de MS
.ie t \&\f(CB\\$1\f(NR(\\$2)\\$3
.el \fI\\$1\fP(\\$2)\\$3
..
.TH SYLLIFY_LEXICON 1 "1998oct30" fosler   \" $Header: /u/drspeech/src/syllify/RCS/syllify_lexicon.man,v 1.2 1998/10/31 02:42:42 fosler Exp $
.SH NAME
syllify_lexicon \- Syllabify a noway lexicon
.SH SYNOPSIS
.B syllify_lexicon
[\fBindct\fR=<file>]
[\fBoutdct\fR=<file>]
[\fIother opts\fR]
.SH DESCRIPTION
.PP
This program is used to convert a noway dictionary into a syllabified
dictionary by inserting inter-syllabic markers.  This program is
useful for people working with syllable recognition, but who wish to
exploit the more common phoneme-based training corpora.
.PP
The core of the program is actally the syllabifier program
.MS tsylb2 1
written by Bill Fisher of NIST, which is itself an implementation of the 
rules described in Dan Kahn's 1976 thesis.  The 
.MS tsylb2 1 
program runs interactively, taking prompted input from the console, and 
printing out formatted displays.  The purpose of the 
.PN syllify
script is to read a noway dictionary, feed the pronunciations therin to 
.PN tsylb2
in a format it accepts, then extract the syllabification information from 
its output.  In the process, 
.PN syllify
handles issues such as label file format conversion, phoneset 
mappings, segmentation on "h#" (nonspeech) tokens, and reassignment of 
diacritics.

.SH OPTIONS
The following options are accepted (defaults in parens):
.SS Finding input and output files
.TP
.B indct=\fIfile\fR (required)
The name of a noway dictionary to syllabify
.TP
.B outdct=\fIfile\fR (required)
The name of a syllabified noway dictionary to write out.
.TP
.B keepdias=\fIbool\fR (1)
This option controls the treatment of 
diacritics (extensions to phoneme labels of the form "_cr", "_n" etc. 
which indicate a deviation from the canonical form of the segment as 
croaky, nasalized etc.)  Diacritics must be stripped as part of the 
preprocessing required for \f4tsylb\f1.  Normally they are restored to the 
output token to which the input label contributed; with 
\f4keepdias=0\f1, they are simply discarded.
.TP
.B mergecls=\fIbool\fR (0)
Closure labels (e.g. pcl, tcl) are not known to tsylb, and thus 
must be pre-processed in some way.  The default behavior is to 
merge them when they are followed by corresponding bursts (i.e. "tcl t") 
but to leave them as separate instances of the stop in other cases 
(thus "tcl ch" becomes "t ch").  Alternatively, specifying \f4mergecls=1\f1, 
the closure is merged into the following label whatever it is, but 
a warning is printed if it is not the canonical release.  
This may hide closures that are intended as 
syllable-final stops. (See BUGS).
.TP
.B xs2next=\fIbool\fR (0)
.I tsylb
may occasionally leave phones outside of any syllable as 'extrasyllabics'.  
Since we want syllables, these are simply attached to the nearest available 
syllable, but when the extrasyllabic occurs between two syllables, it 
could go either way.  This flag controls whether they are blindly 
attached to the front of the following syllable (\f4xs2next=1\f1) or 
the end of the preceding syllable (\f4xs2next=0\f1).
.TP
.B map61to56=\fIbool\fR (1)
As a special time-saving feature, this option will automatically perform 
the symbolic mapping of the extra phones in the TIMIT61 phone symbol 
set to their equivalents in the standard ICSI56 phone set.  
I believe the default 
.MS tsylb 1
mapping tables that we have defined don't have the full TIMIT61 set, 
so make sure you use this if your data is TIMIT61.
.TP
.B tsylb_bin=\fIpath\fR (/u/stp/src/tsylb2-1.1/tsylb2)
The path to the executable tsylb binary.  If the shell environment variable
TSYLBBIN is set, it is used as the default.
.TP
.B tsylb_args=\fIargs\fR (-f phon1ax.pcd)
Arguments to tsylb, which define the phoneset translation and 
syllabifaction tables to be used.
.TP
.B debug=\fIbool\fR (0)
Print extra debugging information
.TP
.B verbose=\fIbool\fR (0)
Print progress information, one line per completed file.
.TP
.B help=\fIany\fR ()
Just print the usage message and quit.
.SH OTHER OPTIONS
Within the script, there is a list of phoneme token mappings (\f4tokenmap\f1) 
and patterns to trigger warnings (\f4warns\f1) which could be edited easily to 
customize the program.  Although it might be desirable to make these 
command-line options, I'm not sure how to allow the user to specify them 
in a robust manner.  (\f4tokenmap\f1 is a Tcl list of "regsub" pairs; 
\f4warns\f1 is a list of "glob" patterns).  
.PP
As it stands, \f4tokenmap\f1 makes the following translations:
phoneme labels "UNL", "unl", "?" and "!" become "" (i.e. they are deleted, 
meaning their time support is merged with the following phoneme); 
"SIL", "sil", "SP" and "sp" are mapped to "h#", the generic ICSI-56 
silence/nonspeech label.  This map is augmented by the TIMIT-to-ICSI
rules when map61to56 is specified.
.SH NOTES
This script (and man page) is derived from the 
.PN syllify
script of Dan Ellis.
.SH BUGS
Tsylb doesn't handle separate stop-closure symbols, so these are all 
collapsed into the following matching release by default, otherwise 
left as separate stops.  Unfortunately, when 
a closure is not followed by the corresponding release, this can 
cause weirdness.  For instance, in the NUMBERS95 hand transcriptions, 
the <tcl> symbol is often used where a glottal stop (<q>) might be 
preferred; this final-tcl is typically lost during the tsylb 
preprocessing (with a warning such as "tcl merged to *END*").
Really, we should handle this more intelligently, to permit 
separate treatment of final-closures and pre-burst closures.
.P
The options which currently require editing the script should be made 
command-line options.
.PP
It depends on 
.PN tsylb2
being installed, and on knowing where to find it.  Our installed version of 
.PN tsylb2
is slightly patched to be ICSI-56 phoneset friendly, but these changes 
aren't documented, so they will be lost if we install a new version.
.SH SEE ALSO
.MS tsylb2 1 ,
.MS syllify 1 ,
.MS labels2pfile 1 .
.SH AUTHOR
Eric Fosler-Lussier
.B fosler@icsi.berkeley.edu
